;: kotkovets aka  
;http://forum.oszone.net/member.php?userid=133945

!ifndef MSI_INCLUDED
!define MSI_INCLUDED

!include Util.nsh
!include LogicLib.nsh

!verbose push
!verbose 3
!ifndef _MSI_VERBOSE
  !define _MSI_VERBOSE 3
!endif
!verbose ${_MSI_VERBOSE}
!define MSI_VERBOSE `!insertmacro MSI_VERBOSE`
!verbose pop

!macro MSI_VERBOSE _VERBOSE
  !verbose push
  !verbose 3
  !undef _MSI_VERBOSE
  !define _MSI_VERBOSE ${_VERBOSE}
  !verbose pop
!macroend

!define MsiProductState    "!insertmacro GetProductStateCall"
!define MsiOpenProductInfo "!insertmacro CallMsiOpenProduct"
!define MsiEnumProducts    "!insertmacro MsiEnumProductsCall"
!macro __DefineProductInfo PROPERTY
  !define msi${PROPERTY}   "!insertmacro GetMsiProductInfoCall ${PROPERTY}"
!macroend
!insertmacro __DefineProductInfo VersionString
!insertmacro __DefineProductInfo InstallDate
!insertmacro __DefineProductInfo InstallSource
!insertmacro __DefineProductInfo ProductID
!insertmacro __DefineProductInfo PackageCode
!insertmacro __DefineProductInfo InstalledProductName
!insertmacro __DefineProductInfo ProductName
!insertmacro __DefineProductInfo PackageName
!insertmacro __DefineProductInfo RegOwner
!insertmacro __DefineProductInfo RegCompany
!insertmacro __DefineProductInfo VersionMajor
!insertmacro __DefineProductInfo VersionMinor
!insertmacro __DefineProductInfo HelpTelephone
!insertmacro __DefineProductInfo HelpLink
!insertmacro __DefineProductInfo ProductIcon
!insertmacro __DefineProductInfo Publisher
!insertmacro __DefineProductInfo AuthorizedLUAApp
!insertmacro __DefineProductInfo Language
!insertmacro __DefineProductInfo LocalPackage
!insertmacro __DefineProductInfo Transforms
!insertmacro __DefineProductInfo InstanceType

!macro GetProductStateCall ProductCode VAR
   !verbose push
   !verbose ${_MSI_VERBOSE}
   Push `${PRODUCTCODE}`
   ${CallArtificialFunction} GetProductState_
   Pop `${VAR}`
   !verbose pop
!macroend

!macro GetMsiProductInfoCall PRODUCTCODE PROPERTY OUTPUT
   !verbose push
   !verbose ${_MSI_VERBOSE}
   Push `${PRODUCTCODE}`
   Push `${PROPERTY}`
   ${CallArtificialFunction} GetMsiProductInfo_
   Pop `${OUTPUT}`
   !verbose pop
!macroend

!macro CallMsiOpenProduct PROPERTY PATH_MSI OUTPUT
   !verbose push
   !verbose ${_MSI_VERBOSE}
   Push "select `Value` from `Property` where `Property` = '${PROPERTY}'"
   Push `${PATH_MSI}`
   ${CallArtificialFunction} MsiOpenProduct_
   Pop `${OUTPUT}`
   !verbose pop
!macroend

!macro MsiEnumProductsCall _FUNC
   !verbose push
   !verbose ${_MSI_VERBOSE}
   Push `$0`
   GetFunctionAddress $0 `${_FUNC}`
   Push `$0`
   ${CallArtificialFunction} MsiEnumProducts_
   Pop `$0`
   !verbose pop
!macroend

!macro GetMsiProductInfo_
  !verbose push
  !verbose ${_MSI_VERBOSE}
   System::Store S
   System::Call "msi::MsiGetProductInfo(tss, tss, in, *i.r0)"
   IntOp $0 $0 + 1
   System::Call "msi::MsiGetProductInfo(ts, ts, t.r2, *ir0)i.r1"
   ${Select} $1
        ${Case4} 87 234 1608 1615
            Push "error"
        ${Case} 1605
            Push $1
        ${Case} 0
            Push `$2`
        ${Default}
   ${EndSelect}
   System::Store L
   !verbose pop
!macroend

!macro GetProductState_
   !verbose push
   !verbose ${_MSI_VERBOSE}
   System::Store S
   System::Call "msi::MsiQueryProductState(ts)i.r0"
   IntCmp $0 -2 +1 +2 +2
   Push "INSTALLSTATE_INVALIDARG" # invalid function argument
   IntCmp $0 -2 +2 +2 +1
   Push $0
   System::Store L
   !verbose pop
!macroend

!macro MsiOpenProduct_
   !verbose push
   !verbose ${_MSI_VERBOSE}
    System::Store S
    System::Call "msi::MsiOpenDatabase(ts, i0, *i.r0)i.r4"
    ${If} $4 == 0
       System::Call "msi::MsiDatabaseOpenView(ir0, ts, *i.r1)i.r4"
       ${If} $4 == 0
          System::Call "msi::MsiViewExecute(ir1, i0)"
          System::Call "msi::MsiViewFetch(ir1, *i.r2)i.r4"
          ${If} $4 == 0
             System::Call "msi::MsiRecordGetString(ir2, i1, i0, *i.r3)"
             IntOp $3 $3 + 1
             System::Call "msi::MsiRecordGetString(ir2, i1, t.s, *ir3)"
             System::Call "msi::MsiCloseHandle(ir2)"
          ${Else}
             Push "ERROR_INVALID_PARAMETER"
          ${EndIf}
          System::Call "msi::MsiViewClose(ir1)"
       ${Else}
          Push "ERROR_BAD_QUERY_SYNTAX"
       ${EndIf}
       System::Call "msi::MsiCloseHandle(ir0)"
    ${Else}
       Push "ERROR_OPEN_FAILED"
    ${EndIf}
    System::Store L
   !verbose pop
!macroend

!macro MsiEnumProducts_
   !verbose push
   !verbose ${_MSI_VERBOSE}
   System::Store S
   Pop $3
   StrCpy $0 0
   StrCpy $1 0
   ClearErrors
   ${Do}
       System::Call "msi::MsiEnumProducts(ir1,t.r4)i.r2"
       ${IfThen} $2 != 0 ${|}${Break}${|}
       Call $3
       Pop `$0`
       ${If} $0 == `StopMsiEnum`
       ${OrIf} ${Errors}
          ${Break}
       ${EndIf}
       IntOp $1 $1 + 1
   ${Loop}
   System::Store L
   !verbose pop
!macroend

!endif